// MyTest.h : Declaration of the CMyTest

#pragma once
#include "resource.h"       // main symbols

#include "TestATL_i.h"


#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif



// CMyTest

class ATL_NO_VTABLE CMyTest :
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CMyTest, &CLSID_MyTest>,
	public IDispatchImpl<IMyTest, &IID_IMyTest, &LIBID_TestATLLib, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CMyTest()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_MYTEST)


BEGIN_COM_MAP(CMyTest)
	COM_INTERFACE_ENTRY(IMyTest)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()



	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

public:
	STDMETHOD(PrepareBuf1)(__int64 buffer [], int bufLength)
	{
		for (int i = 0; i < bufLength; i ++ )
		{
			buffer[i] = i;
		}

		return S_OK;
	}

	STDMETHOD(PrepareBuf2)(__int64 buffer, int bufLength)
	{
		__int64 *pBuffer = (__int64 *)buffer;

		for (int i = 0; i < bufLength; i ++ )
		{
			pBuffer[i] = i;
		}

		return S_OK;
	}
};

OBJECT_ENTRY_AUTO(__uuidof(MyTest), CMyTest)
